import argparse
import numpy as np
import matplotlib.pyplot as plt
import matplotlib.animation as animation

import sys
import sympy

ON = 1
OFF = 0
vals = [ON, OFF]


def load_file(N): #path, delimiter
    #### OVDJE IDE INPUT FILE #######
    a = np.loadtxt("OVDJE IDE IME VASEG FILEA", dtype=int, delimiter=',')

    enumerator = 1
    for i in range(len(a)):
      for j in range(len(a)):
          if sympy.isprime(enumerator):
              a[i][j] = 0
          else:
              pass
          enumerator +=1

    print(a)
    return a


def check_inside(x,y,N):

    if x < 0:
        return False

    if y < 0:
        return False

    if x >= N:
        return False

    if y >= N:
        return False

    return True


generation = 1
count_419 = 0
count_420 = 0

def update(frameNum, img, grid, N):
    global generation 
    print(generation)
    newGrid = grid.copy()

    enumerator = 1
    for i in range(N):
        for j in range(N):
            # compute 8-neighbor sum
            # using toroidal boundary conditions - x and y wrap around
            # so that the simulation takes place on a toroidal surface.

            # total = int((grid[i, (j-1)%N] + grid[i, (j+1)%N] +
            #           grid[(i-1)%N, j] + grid[(i+1)%N, j] +
            #           grid[(i-1)%N, (j-1)%N] + grid[(i-1)%N, (j+1)%N] +
            #           grid[(i+1)%N, (j-1)%N] + grid[(i+1)%N, (j+1)%N])/1)

            total = 0
            for di in [-1, 0, 1]:
                for dj in [-1, 0, 1]:
                    if di == 0 and dj == 0:
                        continue
                    ni = i+di 
                    nj = j+dj

                    if not(check_inside(ni, nj, N)):
                        continue

                    total += grid[ni, nj]
            


            # TASK 2 
            if sympy.isprime(enumerator):
              newGrid[i][j] = OFF

            elif grid[i, j]  == ON:
                if (total < 2) or (total > 3):
                    newGrid[i, j] = OFF
            else:
                if total == 3:
                    newGrid[i, j] = ON

            enumerator +=1
            
    # update data

    print(sum(sum(grid)))
    grid[:] = newGrid[:]
    img.set_data(newGrid)

    tree_count = sum(sum(grid))
    
    plt.title("Number of trees: {}".format(tree_count))

    if generation == 419:
        global count_419
        count_419 = tree_count

    if generation == 420:
        global count_420
        count_420 = tree_count

        print(generation)
        print("system is active: {}".format(count_419 != count_420))
        print("Generation: {} Number of trees: {}".format(generation, tree_count))
        print(count_420, count_419)

        sys.quit()
        
    generation+=1
    return img,

# main() function
def main():

    # Command line args are in sys.argv[1], sys.argv[2] ..
    # sys.argv[0] is the script name itself and can be ignored
    # parse arguments
    parser = argparse.ArgumentParser(description="Runs Conway's Game of Life simulation.")
    # add arguments
    parser.add_argument('--mov-file', dest='movfile', required=False)
    args = parser.parse_args()
    
    # set grid size
    N = 200
    # set animation update interval
    updateInterval = 1


    grid = np.array([])
    grid = load_file(N)

    fig, ax = plt.subplots()
    img = ax.imshow(grid, interpolation='nearest')

    ani = animation.FuncAnimation(fig, update, fargs=(img, grid, N, ),
                                frames = 10,
                                interval=updateInterval,
                                save_count=50)
    
    # ani.save('basic_animation.mp4', writer = writer, fps=30)

    plt.show()


if __name__ == '__main__':
    main()
